#include <iostream>
#include <string>

using namespace std;

int main()
{
	int i,j,r,s1,s2;
	string T;
	char p;
	cin>>T;
	s1=0;
	s2=0;
	for(i=0;i<T.length();i++)
    {
    	if(T.at(i)!=T.at(T.length()-1-i))
    	{
    		
    		for(j=i+1;j<T.length();j++)
    		{
    			if(T.at(j)==T.at(i))
    			{
    				p=T.at(T.length()-1-i);
    				T.at(T.length()-1-i)=T.at(j);
    				T.at(j)=p;
    				if(s1>j||s1==0)
    				{
    					s1=j;
					}
					if(s2<T.length()-1-i||s2==0)
					{
						s2=T.length()-1-i;
					}
    				break;
				}else if(j==T.length()-1)
				{
					p=T.at(T.length()/2);
    				T.at(T.length()/2)=T.at(i);
    				T.at(i)=p;
    				if(s1>i||s1==0)
    				{
    					s1=i;
					}
					if(s2<T.length()/2||s2==0)
					{
						s2=T.length()/2;
					}
				}
			}
		}
	}
	r=s2-s1+1;
	cout<<r;
	return 0;
}